package org.fuseri.modulelanguageschool.course;

import org.fuseri.model.dto.course.CourseCreateDto;
import org.fuseri.model.dto.course.CourseDto;
import org.mapstruct.Mapper;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import java.util.List;

@Mapper(componentModel = "spring")
public interface CourseMapper {

    CourseDto mapToDto(Course course);

    Course mapToCourse(CourseDto courseDto);

    List<CourseDto> mapToList(List<Course> persons);


    default Page<CourseDto> mapToPageDto(Page<Course> courses) {
        return new PageImpl<>(mapToList(courses.getContent()), courses.getPageable(), courses.getTotalPages());
    }

    Course mapToCourse(CourseCreateDto dto);
}

